#pragma once
#include <string>

#include "DeerRender/UIEngine/Functions/UIEngine_TextFunctions.h"
#include "DeerRender/UIEngine/Functions/UIEngine_ColumnFunctions.h"
#include "DeerRender/UIEngine/Functions/UIEngine_ButtonFunctions.h"
#include "DeerRender/UIEngine/Functions/UIEngine_ButtonFunctions.h"

class asSMessageInfo;
namespace Deer {
    namespace UIEngine {
        // --- Mesh Data Store ---

        // Returns the count of meshes in the dir relative to the mesh root dir
        int getMeshCount(std::string& dir);
        // Returns the path to the mesh with id i
        std::string getMeshPath(std::string& dir, int i);
        // Returns the name of the mesh with id i
        std::string getMeshName(std::string& dir, int i);

        // Returns the count of sub dirs in the dir relative to the mesh root dir
        int getMeshDirCount(std::string& dir);
        // Returns the path to the subDir in the dir relative to the mesh root dir
        std::string getMeshDirPath(std::string& dir, int i);
        // Returns the name of the subDir in the dir relative to the mesh root dir
        std::string getMeshDirName(std::string& dir, int i);

        // --- RENDERING ---

        // TEXT
        // Images
        // TODO: Implement
        void drawIcon(std::string& iconId, int size);



        void errorCallback(const asSMessageInfo *msg, void *param);
        // Prints in console a mesage
        void print(std::string& msg);
    }
}